#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <graphics.h>
#include <dos.h>
#include <math.h>

float hour, min, sec;
float p_hour, p_min, p_sec;
int cx, cy;

void StartGraphics()
{
  int gdriver = DETECT, gmode, errorcode;
  initgraph(&gdriver, &gmode, "");
  errorcode = graphresult();
  if (errorcode != grOk)
  {
    printf("Graphics error: %s\n", grapherrormsg(errorcode));
    printf("Press any key to halt:");
    getch();
    exit(1);
  }
}

void GetTimeData()
{
  struct time t;
  gettime(&t);
  hour = t.ti_hour;
  min = t.ti_min;
  sec = t.ti_sec;
}

void DrawDigits()
{
  int i;
  char *dig;
  setcolor(6);
  circle(cx, cy, 190);
  settextjustify(1,1);
  for(i=1;i<=60;i++)
  {
    dig = new char[3];
    if(i%5==0)
    {
      sprintf(dig,"%d",i/5);
      outtextxy(cx+180*sin(i/5*M_PI/6),cy+180*-cos(i/5*M_PI/6),dig);
    }
    else
      outtextxy(cx+180*sin(i*M_PI/30),cy+180*-cos(i*M_PI/30),".");
    delete dig;
  }
}

void DrawTime()
{
  setcolor(7);
  moveto(getmaxx() / 2, getmaxy() / 2);
  linerel(sin((p_hour+p_min/60)*5 * M_PI / 30) * 140, -cos((p_hour+p_min/60)*5 * M_PI / 30) * 140);
  setcolor(7);
  moveto(getmaxx() / 2, getmaxy() / 2);
  linerel(sin((p_min+p_sec/60) * M_PI / 30) * 170, -cos((p_min+p_sec/60) * M_PI / 30) * 170);
  setcolor(7);
  moveto(cx, cy);
  linerel(sin(p_sec * M_PI / 30) * 160, -cos(p_sec * M_PI / 30) * 160);
  setcolor(8);
  moveto(getmaxx() / 2, getmaxy() / 2);
  linerel(sin((hour+min/60)*5 * M_PI / 30) * 140, -cos((hour+min/60)*5 * M_PI / 30) * 140);
  setcolor(8);
  moveto(getmaxx() / 2, getmaxy() / 2);
  linerel(sin((min+sec/60) * M_PI / 30) * 170, -cos((min+sec/60) * M_PI / 30) * 170);
  setcolor(12);
  moveto(cx, cy);
  linerel(sin(sec * M_PI / 30) * 160, -cos(sec * M_PI / 30) * 160);
}

void main()
{
  char k;
  StartGraphics();
  cleardevice();
  setbkcolor(7);
  cx = getmaxx() / 2;
  cy = getmaxy() / 2;
  DrawDigits();
  while(!kbhit())
  {
    GetTimeData();
    if(p_sec != sec)
    {
      DrawTime();
      p_sec = sec;
      p_min = p_min != min ? min : p_min;
      p_hour = p_hour != hour ? hour : p_hour;
    }
    delay(50);
  }
}